﻿//Drop-down reference links menu. Based on Inline HTML Tooltip script
var refLinksMenu = {
	anchors: [], //array of anchor links
	divs: [], //array of references to all reflinkmenu DIVs on the page
	visibles: [], //array of visibility states

	positionDiv:function(divindex){
	  var anchor = this.anchors[divindex];
	  if (typeof anchor !== 'undefined'){
	   anchor = $(anchor);
	   var offset = anchor.offset();
	   offset.top += anchor.height();
	   var div = $(this.divs[divindex]);
	   
	   //account for right edge
	   var divWidth = div.width();
	   if ($(document).width() < offset.left + divWidth) {
		offset.left -= divWidth;
	   }
	   
	   //account for bottom edge
	   var divHeight = div.height();
	   if ($(document).height() < offset.top + divHeight) {
		offset.top -= divHeight + anchor.height();
	   }
	   
	   div.css({left: offset.left, top: offset.top});
	  }
	 },	
	
	showHideDiv:function(divindex){
		if (!this.visibles[divindex]){
			refLinksMenu.showDiv(divindex);
		}else{
			refLinksMenu.hideDiv(divindex);
		}
	},
	
	showDiv:function(divindex){
		var div = this.divs[divindex];
		var anchor = this.anchors[divindex];
		if (typeof div != 'undefined' && typeof anchor != 'undefined'){
			$(div).hide();
			$(div).slideToggle("fast");
			$(anchor).toggleClass("hover");
			this.visibles[divindex] = true;
		}
	},
	
	hideDiv:function(divindex){
		var div = this.divs[divindex];
		var anchor = this.anchors[divindex];
		if (typeof div != 'undefined' && typeof anchor != 'undefined'){
			$(div).show();
			$(div).slideToggle("fast");
			$(anchor).removeClass("hover");
			this.visibles[divindex] = false;
		}
	},

	updateanchordimensions:function($){
		$("a[href=#reflink]").each(function(index){
			this.dimensions = {w: this.offsetWidth, h: this.offsetHeight, offsetx: $(this).offset().left, offsety: $(this).offset().top};
		});
	},
	
	render:function(){
		refLinksMenu.iebody = (document.compatMode && document.compatMode != "BackCompat") ? document.documentElement : document.body;
		refLinksMenu.divs.length = 0;
		refLinksMenu.anchors.length = 0;
		refLinksMenu.visibles.length = 0;
		$("a[href=#reflink]").each(function(index){
			this.dimensions = {w: this.offsetWidth, h: this.offsetHeight, offsetx: $(this).offset().left, offsety: $(this).offset().top};
			this.pos = index + ' pos';
			var div = $('#' + this.rel).get(0);
			if (div == null) //if no corresponding div found
				return; 
				
			div.dimensions = {w: div.offsetWidth, h: div.offsetHeight};
			$(div).remove().appendTo('body'); //add div to end of BODY for easier positioning
//			$(div).remove().appendTo('#content'); //add div to end of div.content (there was a problem with positioning in web documentation)
			refLinksMenu.divs.push(div); //store reference to each div
			refLinksMenu.anchors.push(this); //store reference to each anchor
			refLinksMenu.visibles.push(false);
			
			var $anchor = $(this);
			$anchor.unbind("click");
			$anchor.bind("click", function(){ 
				refLinksMenu.positionDiv(parseInt(this.pos));
				refLinksMenu.showHideDiv(parseInt(this.pos));
				}
			);
		});

		$(window).unbind("resize");
		$(window).bind("resize", function(){refLinksMenu.updateanchordimensions($)});
	}
}

function blinkElement(id) {
	$(id + " h2").highlightFade({ speed: 300, iterator: 'sinusoidal', complete: function() { $(id + " h2").highlightFade({ speed: 300, iterator: 'sinusoidal'}); } });
}
function toggleExpandAll(sender) {
	var collapseAll = 'Collapse All Sections';
	var expandAll = 'Expand All Sections';
	if (helpLanguage == "ru") {
		collapseAll = 'Свернуть всё';
		expandAll = 'Развернуть всё';
	}
	if (sender.className == 'collapse') { 
		$(".collapsable").hide(); 
		$(sender).find('a').html(expandAll); 
		$('.collapse').addClass('expand'); 
	}
	else { 
		$(".collapsable").show(); 
		$(sender).find('a').html(collapseAll); 
		$('.collapse').removeClass('expand'); 
	}
}

function getLangs(){
	if (frameElement == null)
		return window.name;
	else
		return parent.name;
}

function setLangs(langs){
	if (frameElement == null)
		window.name = langs;
	else
		parent.name = langs;
}

$(window).load(function() {
    if (window.location.toString().indexOf("#") > 0) {
        var str = document.location.toString().substring(document.location.toString().indexOf("#"), document.location.toString().length);
        blinkElement(str);
    }

    $("#body .collapse").click(function() {
        if (!$(this).hasClass('expand')) {
            $(this).parents('.section').find(".collapsable").hide();
        } else {
            $(this).parents('.section').find(".collapsable").show();
        }
        $(this).toggleClass('expand');
        return false;
    });

    function initlangaugeMenu() {
	    var menu = document.createElement("ul");
        menu.id = "langaugeMenu";
		
		for (var i = 0; i < langs.length; i++){
			var li = document.createElement("li");
			var chk = document.createElement("input");
			var label = document.createElement("label");
			chk.id = "lng_" + langs[i].key;
			chk.type = "checkbox";
			chk.value = langs[i].key;
			label.innerHTML = langs[i].value;
			li.appendChild(chk);
			li.appendChild(label);
			menu.appendChild(li);	
		}

        $("#langaugeFilter").append(menu);
        $('#langaugeMenu li').each(function() {
            $(this).find("label").attr("for", "lng_" + $(this).find("input").val());
			$(this).find("input").attr("checked", (getLangs() == null || (getLangs() != null && getLangs().indexOf($(this).find("input").val()) == -1)) ? "checked" : "");
        });
        $("#langaugeMenu input").click(function() { updateLanguagesState(); });
        updateLanguagesState();
    }

    function updateLanguagesState(obj) {
		var excludedLangs = new Array();
		for (var i = 0; i < langs.length; i++){
			if (getLangs() != null && getLangs().indexOf(langs[i].key) > -1){
				if (!isChecked(langs[i].key))
					excludedLangs.push(langs[i].key);
			}else{
				if (inFilter(langs[i].key) && !isChecked(langs[i].key))
					excludedLangs.push(langs[i].key);
			}
		}

		setLangs(excludedLangs.join());
		
		for (var i = 0; i < langs.length; i++){
			if ($.inArray(langs[i].key, excludedLangs) > -1)
				$("div.code." + langs[i].key).hide();
			else
				$("div.code." + langs[i].key).show();
		}
		
		if ($("#langaugeMenu input:checked").length == $("#langaugeMenu input").length) {
            $("#currentLanguages").html("all languages");
        }
        else if ($("#langaugeMenu input:checked").length == 0) {
            $("#currentLanguages").html("none");
        }
		else{
			var str = "";
            $('#langaugeMenu input:checked').each(function() {
				var lang = document.getElementById("lng_" + $(this).val()).parentNode.lastChild.innerHTML; 
				str += "<strong>" + lang + "</strong>, " });
            str = str.substring(0, str.length - 2);
            $("#currentLanguages").html(str);
		}		
		
		$("div.reflinkmenu").each(function(){
			var wasHidden = $(this).is(":hidden");
			if (wasHidden)
				$(this).show();
			//update reference links in accordance with language filter
			$(this).find("a").each(function(){
				if (getLangs() != null && getLangs().indexOf(this.rel) > -1)
					$(this).parent().hide();
				else
					$(this).parent().show();
			})			
			
			//show all links if all languages are hidden
			if ($(this).find("li:visible").length == 0){
				$(this).find("li").each(function(){
					$(this).show();
				});
			}
						
			//remove menu if the only one language is selected
			var parentLink = $("a[rel=" + this.id + "]").get(0);
			if ($(this).find("li:visible").length == 1){
				var li = $(this).find("li:visible").get(0);
				var a = $(li).find("a").get(0);
				$(parentLink).attr("href", a.href);
				$(parentLink).removeClass("anchor");
			}			
			//revert the menu back
			else if ($(this).find("li:visible").length > 1){
				$(parentLink).attr("href", "#reflink");
				$(parentLink).addClass("anchor");
			}
			
			if (wasHidden)
				$(this).hide();
		});			
		
		refLinksMenu.render();
		
		function isChecked(key){
			var result = false;
			$('#langaugeMenu input').each(function() {
				if ($(this).val() == key && $(this).is(':checked')){
					result = true;
					return;
				}
			});
			return result;
		}
		
		function inFilter(key){
			var result = false;
			$('#langaugeMenu input').each(function() {
				if ($(this).val() == key){
					result = true;
					return;
				}
			});
			return result;
		}
    }
	
	initlangaugeMenu();
    $("#langaugeFilter").show();
    $("#langaugeFilter a").click(function() {
        $("#langaugeMenu").slideToggle("fast");
        $(this).toggleClass("hover");
        return false;
    });
		
    $("#container").click(function(e) {
        $("#langaugeMenu:visible").slideUp("fast");
        $("#langaugeFilter a").removeClass("hover");
		targetUndefined = typeof e.target.rel == 'undefined';
		if (typeof e.srcElement != 'undefined') {
			targetUndefined = targetUndefined || typeof e.srcElement.rel == 'undefined';
		}
		if (targetUndefined){
			for (var i = 0; i < refLinksMenu.divs.length; i++){
				if (refLinksMenu.visibles[i])
					refLinksMenu.hideDiv(i);
			}
		}
    })
			
    $("#content").scroll(function(e) {
		$("#container").click();
    })
	
    $("a[target]").addClass("external");
    $("#header a[href=#seeAlsoToggle]").click(function() {
        $("#seeAlsoToggle .collapsable").show();
        $("#seeAlsoToggle .collapse").removeClass("expand");
        $.scrollTo('#seeAlsoToggle', 500, { onAfter: function() { blinkElement('#seeAlsoToggle'); } });
    });
	    $("#header a[href=#propertyTableToggle]").click(function() {
        $("#propertyTableToggle .collapsable").show();
        $("#propertyTableToggle .collapse").removeClass("expand");
        $.scrollTo('#propertyTableToggle', 500, { onAfter: function() { blinkElement('#propertyTableToggle'); } });
    });
	    $("#header a[href=#methodTableToggle]").click(function() {
        $("#methodTableToggle .collapsable").show();
        $("#methodTableToggle .collapse").removeClass("expand");
        $.scrollTo('#methodTableToggle', 500, { onAfter: function() { blinkElement('#methodTableToggle'); } });
    });
	    $("#header a[href=#eventTableToggle]").click(function() {
        $("#eventTableToggle .collapsable").show();
        $("#eventTableToggle .collapse").removeClass("expand");
        $.scrollTo('#eventTableToggle', 500, { onAfter: function() { blinkElement('#eventTableToggle'); } });
    });
	$("#header a[href=#constructorTableToggle]").click(function() {
        $("#constructorTableToggle .collapsable").show();
        $("#constructorTableToggle .collapse").removeClass("expand");
        $.scrollTo('#constructorTableToggle', 500, { onAfter: function() { blinkElement('#constructorTableToggle'); } });
    });
	$("#header a[href=#ExplicitInterfaceImplementationTableToggle]").click(function() {
        $("#ExplicitInterfaceImplementationTableToggle .collapsable").show();
        $("#ExplicitInterfaceImplementationTableToggle .collapse").removeClass("expand");
        $.scrollTo('#ExplicitInterfaceImplementationTableToggle', 500, { onAfter: function() { blinkElement('#ExplicitInterfaceImplementationTableToggle'); } });
    });

});