#!/usr/bin/perl

use CGI qw/:standard/;
use File::Basename;
use File::stat;
use File::Spec;

#This is a base server folder for subfolders, between which the user can choose
my $strBasePath = File::Spec->rel2abs("../Basic/");
my $strFolderPath = "Folder1/";

#Construct and encode a URL of the supplied file for reliable HTTP transmission to the client
sub EncodeFileName {
	my $strName = CGI::escape($strFolderPath . @_[0]);
	$strName =~ s/%2F/\//ig;
	return $strName;
}

print "Content-Type: text/plain;charset=utf-8\r\n\r\n";

my $strRequest = param("id");
#Check if the id parameter is passed
if ($strRequest != ""){
	#Change the subfolder, if needed
	if ($strRequest eq "2"){
		$strFolderPath = "Folder2/";
	}
	elsif ($strRequest eq "3"){
		$strFolderPath = "Folder3/";
	}
}

#Check if the selected subfolder exists
$objDir = File::Spec->join($strBasePath, $strFolderPath);

if (-e $objDir && -d $objDir){
	opendir(DIR, $objDir);
	my @files = grep {/^[^\.]/ && -f "$objDir/$_"} readdir(DIR);
	#Iterate through all files in the subfolder and build a file list
    foreach my $objFile (@files) {
		#Add the MIME type, the size, and the name for saving
		print "*/* | " . (-s File::Spec->join($objDir, $objFile)) . " | " . $objFile . " | ";
		#Add the URL to the file and the CRLF combination
        print EncodeFileName($objFile) . "\r\n";
    }
    closedir(DIR);
}
